﻿namespace SuperName
{
    class IsFirstTabPropertyMonitor
    {
        class TabInfo
        {
            public TabInfo(System.Windows.Controls.TabItem item, System.EventHandler handler)
            {
                this.item = item;
                this.handler = handler;
            }

            public System.Windows.Controls.TabItem item;
            public System.EventHandler handler;
        }

        public delegate void FirstTabPropertyChangedDelegate(TabsStudioExt.Tab tab);
        public event FirstTabPropertyChangedDelegate OnFirstTabPropertyChanged;

        public IsFirstTabPropertyMonitor()
        {
            openTabs = new System.Collections.Generic.List<TabInfo>();
        }

        public void OnTabCreated(TabsStudioExt.TabEventArgs e)
        {
            TabInfo info = new TabInfo(e.Tab.TabItem,
                (object o, System.EventArgs a) =>
                { if (OnFirstTabPropertyChanged != null) OnFirstTabPropertyChanged(e.Tab); });
            openTabs.Add(info);
            System.ComponentModel.DependencyPropertyDescriptor d = GetIsFirstTabDescriptor(e.Tab.TabItem);
            if (d != null)
                d.AddValueChanged(info.item, info.handler);
        }

        public void OnTabDestroyed(TabsStudioExt.TabEventArgs e)
        {
            foreach (TabInfo info in openTabs)
            {
                if (info.item == e.Tab.TabItem)
                {
                    System.ComponentModel.DependencyPropertyDescriptor d = GetIsFirstTabDescriptor(e.Tab.TabItem);
                    if (d != null)
                        d.RemoveValueChanged(info.item, info.handler);
                    openTabs.Remove(info);
                    return;
                }
            }
        }

        private System.ComponentModel.DependencyPropertyDescriptor GetIsFirstTabDescriptor(System.Windows.Controls.TabItem tabItem)
        {
            if (isFirstTabDescriptor == null)
            {
                isFirstTabDescriptor = System.ComponentModel.DependencyPropertyDescriptor.FromName(
                    "SuperGroupIsFirstTab", tabItem.GetType(), tabItem.GetType());
            }
            return isFirstTabDescriptor;
        }

        private System.Collections.Generic.List<TabInfo> openTabs;
        private System.ComponentModel.DependencyPropertyDescriptor isFirstTabDescriptor;
    }
}
